ETHTOOL(8)

NAME
ethtool - query or control network driver and hardware settings

SYNOPSIS

ethtool devname

ethtool -h|--help

ethtool --version

ethtool -a|--show-pause devname

ethtool -A|--pause devname

ethtool -c|--show-coalesce devname

ethtool -C|--coalesce devname

ethtool -g|--show-ring devname

ethtool -G|--set-ring devname

ethtool -i|--driver devname

ethtool -d|--register-dump devname [file name]

ethtool -e|--eeprom-dump devname

ethtool -E|--change-eeprom devname

ethtool -k|--show-features|--show-offload devname

ethtool -K|--features|--offload devname feature ...

ethtool -p|--identify devname [N]

ethtool -P|--show-permaddr devname

ethtool -r|--negotiate devname

ethtool -S|--statistics devname

ethtool -t|--test devname [offline|online|external_lb]

ethtool -s devname speed N [wol p|u|m|b|a|g|s|d...] [sopass xx:yy:zz:aa:bb:cc] [msglvl N | msglvl type ...]

ethtool -n|-u|--show-nfc|--show-ntuple devname [ rx-flow-hash tcp4|udp4|ah4|esp4|sctp4|tcp6|udp6|ah6|esp6|sctp6 |
rule N ]

ethtool -N|-U|--config-nfc|--config-ntuple devname rx-flow-hash tcp4|udp4|ah4|esp4|sctp4|tcp6|udp6|ah6|esp6|sctp6m|v|t|s|d|f|n|r... |
flow-type ether|ip4|tcp4|udp4|sctp4|ah4|esp4 [src xx:yy:zz:aa:bb:cc [m xx:yy:zz:aa:bb:cc]] [dst xx:yy:zz:aa:bb:cc [m xx:yy:zz:aa:bb:cc]] [src-ip x.x.x.x [m x.x.x.x]] [dst-ip x.x.x.x [m x.x.x.x]] |
delete N

ethtool -w|--get-dump devname [data filename]

ethtool -W|--set-dump devname N

ethtool -T|--show-time-stamping devname

ethtool -x|--show-rxfh-indir devname

ethtool -X|--set-rxfh-indir devname [ equal N | weight W0 W1 ... ]

ethtool -f|--flash devname FILE [N]

ethtool -l|--show-channels devname

ethtool -L|--set-channels devname

ethtool -m|--dump-module-eeprom devname

ethtool --show-priv-flags devname

ethtool --set-priv-flags devname flag ...

ethtool --show-eee devname

ethtool --set-eee devname

DESCRIPTION
ethtool is used to query and control network device driver and hardware settings, particularly for wired Ethernet devices.

devname is the name of the network device on which ethtool should operate.

OPTIONS
ethtool with a single argument specifying the device name prints current settings of the specified device.

-h --help
    Shows a short help message.

--version
    Shows the ethtool version number.

-a --show-pause
    Queries the specified Ethernet device for pause parameter information.

-A --pause
    Changes the pause parameters of the specified Ethernet device.

Specifies whether pause autonegotiation should be enabled.

Specifies whether RX pause should be enabled.

Specifies whether TX pause should be enabled.

-c --show-coalesce
    Queries the specified network device for coalescing information.

-C --coalesce
    Changes the coalescing settings of the specified network device.

-g --show-ring
    Queries the specified network device for rx/tx ring parameter information.

-G --set-ring
    Changes the rx/tx ring parameters of the specified network device.

rx N
    Changes the number of ring entries for the Rx ring.

rx-mini N
    Changes the number of ring entries for the Rx Mini ring.

rx-jumbo N
    Changes the number of ring entries for the Rx Jumbo ring.

tx N
    Changes the number of ring entries for the Tx ring.

-i --driver
    Queries the specified network device for associated driver information.

-d --register-dump
    Retrieves and prints a register dump for the specified network device. The register format for some devices is known and decoded others are printed in hex. When raw is enabled, then ethtool dumps the raw register data to stdout. If file is specified, then use contents of previous raw register dump, rather than reading from the device.

-e --eeprom-dump
    Retrieves and prints an EEPROM dump for the specified network device. When raw is enabled, then it dumps the raw EEPROM data to stdout. The length and offset parameters allow dumping certain portions of the EEPROM. Default is to dump the entire EEPROM.

-E --change-eeprom
    If value is specified, changes EEPROM byte for the specified network device. offset and value specify which byte and it's new value. If value is not specified, stdin is read and written to the EEPROM. The length and offset parameters allow writing to certain portions of the EEPROM. Because of the persistent nature of writing to the EEPROM, a device-specific magic key must be specified to prevent the accidental writing to the EEPROM.

-k --show-features --show-offload
    Queries the specified network device for the state of protocol offload and other features.

-K --features --offload
    Changes the offload parameters and other features of the specified network device. The following feature names are built-in and others may be defined by the kernel.

Specifies whether RX checksumming should be enabled.

Specifies whether TX checksumming should be enabled.

Specifies whether scatter-gather should be enabled.

Specifies whether TCP segmentation offload should be enabled.

Specifies whether UDP fragmentation offload should be enabled

Specifies whether generic segmentation offload should be enabled

Specifies whether generic receive offload should be enabled

Specifies whether large receive offload should be enabled

Specifies whether RX VLAN acceleration should be enabled

Specifies whether TX VLAN acceleration should be enabled

Specifies whether Rx ntuple filters and actions should be enabled

Specifies whether receive hashing offload should be enabled

-p --identify
    Initiates adapter-specific action intended to enable an operator to easily identify the adapter by sight. Typically this involves blinking one or more LEDs on the specific network port.

N   Length of time to perform phys-id, in seconds.

-P --show-permaddr
    Queries the specified network device for permanent hardware address.

-r --negotiate
    Restarts auto-negotiation on the specified Ethernet device, if auto-negotiation is enabled.

-S --statistics
    Queries the specified network device for NIC- and driver-specific statistics.

-t --test
    Executes adapter selftest on the specified network device. Possible test modes are:

offline|online|external_lb
    defines test type: offline (default) means to perform full set of tests possibly causing normal operation interruption during the tests, online means to perform limited set of tests do not interrupting normal adapter operation, external_lb means to perform external-loopback test in addition to other offline tests.

-s --change
    Allows changing some or all settings of the specified network device. All following options only apply if -s was specified.

speed N
    Set speed in Mb/s. ethtool with just the device name as an argument will show you the supported device speeds.

Sets full or half duplex mode.

Selects device port.

Specifies whether autonegotiation should be enabled. Autonegotiation
    is enabled by default, but in some network devices may have trouble with it, so you can disable it if really necessary.

advertise N
    Sets the speed and duplex advertised by autonegotiation. The argument is a hexadecimal value using one or a combination of the following values:
    0x001 | 10 Half
    0x002 | 10 Full
    0x004 | 100 Half
    0x008 | 100 Full
    0x010 | 1000 Half | (not supported by IEEE standards)
    0x020 | 1000 Full
    0x8000 | 2500 Full | (not supported by IEEE standards)
    0x1000 | 10000 Full
    0x20000 | 20000MLD2 Full | (not supported by IEEE standards)
    0x40000 | 20000KR2 Full | (not supported by IEEE standards)

phyad N
    PHY address.

Selects transceiver type. Currently only internal and external can be
    specified, in the future further types might be added.

wol p|u|m|b|a|g|s|d...
    Sets Wake-on-LAN options. Not all devices support this. The argument to this option is a string of characters specifying which options to enable.
    p | Wake on PHY activity
    u | Wake on unicast messages
    m | Wake on multicast messages
    b | Wake on broadcast messages
    a | Wake on ARP
    g | Wake on MagicPacket™
    s | Enable SecureOn™ password for MagicPacket™
    d | Disable (wake on nothing). This option clears all previous options.

sopass xx:yy:zz:aa:bb:cc
    Sets the SecureOn™ password. The argument to this option must be 6 bytes in Ethernet MAC hex format (xx:yy:zz:aa:bb:cc).

msglvl N
msglvl type ...
    Sets the driver message type flags by name or number. type names the type of message to enable or disable; N specifies the new flags numerically. The defined type names and numbers are:
    drv | 0x0001 General driver status
    probe | 0x0002 Hardware probing
    link | 0x0004 Link state
    timer | 0x0008 Periodic status check
    ifdown | 0x0010 Interface being brought down
    ifup | 0x0020 Interface being brought up
    rx_err | 0x0040 Receive error
    tx_err | 0x0080 Transmit error
    tx_queued | 0x0100 Transmit queueing
    intr | 0x0200 Interrupt handling
    tx_done | 0x0400 Transmit completion
    rx_status | 0x0800 Receive completion
    pktdata | 0x1000 Packet contents
    hw | 0x2000 Hardware status
    wol | 0x4000 Wake-on-LAN status

    The precise meanings of these type flags differ between drivers.

-n -u --show-nfc --show-ntuple
    Retrieves receive network flow classification options or rules.

rx-flow-hash tcp4|udp4|ah4|esp4|sctp4|tcp6|udp6|ah6|esp6|sctp6
    Retrieves the hash options for the specified flow type.
    tcp4 | TCP over IPv4
    udp4 | UDP over IPv4
    ah4 | IPSEC AH over IPv4
    esp4 | IPSEC ESP over IPv4
    sctp4 | SCTP over IPv4
    tcp6 | TCP over IPv6
    udp6 | UDP over IPv6
    ah6 | IPSEC AH over IPv6
    esp6 | IPSEC ESP over IPv6
    sctp6 | SCTP over IPv6

rule N
    Retrieves the RX classification rule with the given ID.

-N -U --config-nfc --config-ntuple
    Configures receive network flow classification options or rules.

rx-flow-hash tcp4|udp4|ah4|esp4|sctp4|tcp6|udp6|ah6|esp6|sctp6m|v|t|s|d|f|n|r...
    Configures the hash options for the specified flow type.
    m | Hash on the Layer 2 destination address of the rx packet.
    v | Hash on the VLAN tag of the rx packet.
    t | Hash on the Layer 3 protocol field of the rx packet.
    s | Hash on the IP source address of the rx packet.
    d | Hash on the IP destination address of the rx packet.
    f | Hash on bytes 0 and 1 of the Layer 4 header of the rx packet.
    n | Hash on bytes 2 and 3 of the Layer 4 header of the rx packet.
    r | Discard all packets of this flow type. When this option is set, all other options are ignored.

flow-type ether|ip4|tcp4|udp4|sctp4|ah4|esp4
    Inserts or updates a classification rule for the specified flow type.
    ether | Ethernet
    ip4 | Raw IPv4
    tcp4 | TCP over IPv4
    udp4 | UDP over IPv4
    sctp4 | SCTP over IPv4
    ah4 | IPSEC AH over IPv4
    esp4 | IPSEC ESP over IPv4

All fields below that include a mask option may either use "m" to indicate a mask, or may use the full name of the field with a "-mask" appended to indicate that this is the mask for a given field.

src xx:yy:zz:aa:bb:cc [m xx:yy:zz:aa:bb:cc]
    Includes the source MAC address, specified as 6 bytes in hexadecimal separated by colons, along with an optional mask. Valid only for flow-type ether.

dst xx:yy:zz:aa:bb:cc [m xx:yy:zz:aa:bb:cc]
    Includes the destination MAC address, specified as 6 bytes in hexadecimal separated by colons, along with an optional mask. Valid only for flow-type ether.

proto N\fR [\fPm N\fR]\fP
    Includes the Ethernet protocol number (ethertype) and an optional mask. Valid only for flow-type ether.

src-ip x.x.x.x [m x.x.x.x]
    Specify the source IP address of the incoming packet to match along with an optional mask. Valid for all IPv4 based flow-types.

dst-ip x.x.x.x [m x.x.x.x]
    Specify the destination IP address of the incoming packet to match along with an optional mask. Valid for all IPv4 based flow-types.

tos N\fR [\fPm N\fR]\fP
    Specify the value of the Type of Service field in the incoming packet to match along with an optional mask. Applies to all IPv4 based flow-types.

l4proto N\fR [\fPl4m N\fR]\fP
    Includes the layer 4 protocol number and optional mask. Valid only for flow-type ip4.

src-port N\fR [\fPm N\fR]\fP
    Specify the value of the source port field (applicable to TCP/UDP packets) in the incoming packet to match along with an optional mask. Valid for flow-types ip4, tcp4, udp4, and sctp4.

dst-port N\fR [\fPm N\fR]\fP
    Specify the value of the destination port field (applicable to TCP/UDP packets)in the incoming packet to match along with an optional mask. Valid for flow-types ip4, tcp4, udp4, and sctp4.

spi N\fR [\fPm N\fR]\fP
    Specify the value of the security parameter index field (applicable to AH/ESP packets)in the incoming packet to match along with an optional mask. Valid for flow-types ip4, ah4, and esp4.

l4data N\fR [\fPm N\fR]\fP
    Specify the value of the first 4 Bytes of Layer 4 in the incoming packet to match along with an optional mask. Valid for ip4 flow-type.

vlan-etype N\fR [\fPm N\fR]\fP
    Includes the VLAN tag Ethertype and an optional mask.

vlan N\fR [\fPm N\fR]\fP
    Includes the VLAN tag and an optional mask.

user-def N\fR [\fPm N\fR]\fP
    Includes 64-bits of user-specific data and an optional mask.

action N
    Specifies the Rx queue to send packets to, or some other action.
    -1 | Drop the matched flow
    0 or higher | Rx queue to route the flow

loc N
    Specify the location/ID to insert the rule. This will overwrite any rule present in that location and will not go through any of the rule ordering process.

delete N
    Deletes the RX classification rule with the given ID.

-w --get-dump
    Retrieves and prints firmware dump for the specified network device. By default, it prints out the dump flag, version and length of the dump data. When data is indicated, then ethtool fetches the dump data and directs it to a file.

-W --set-dump
    Sets the dump flag for the device.

-T --show-time-stamping
    Show the device's time stamping capabilities and associated PTP hardware clock.

-x --show-rxfh-indir
    Retrieves the receive flow hash indirection table.

-X --set-rxfh-indir
    Configures the receive flow hash indirection table.

equal N
    Sets the receive flow hash indirection table to spread flows evenly between the first N receive queues.

weight W0 W1 ...
    Sets the receive flow hash indirection table to spread flows between receive queues according to the given weights. The sum of the weights must be non-zero and must not exceed the size of the indirection table.

-f --flash  FILE
    Flash firmware image from the specified file to a region on the adapter. By default this will flash all the regions on the adapter.

N   A number to identify flash region where the image should be flashed. Default region is 0 which denotes all regions in the flash.

-l --show-channels
    Queries the specified network device for the numbers of channels it has. A channel is an IRQ and the set of queues that can trigger that IRQ.

-L --set-channels
    Changes the numbers of channels of the specified network device.

rx N
    Changes the number of channels with only receive queues.

tx N
    Changes the number of channels with only transmit queues.

other N
    Changes the number of channels used only for other purposes e.g. link interrupts or SR-IOV co-ordination.

combined N
    Changes the number of multi-purpose channels.

-m --dump-module-eeprom
    Retrieves and if possible decodes the EEPROM from plugin modules, e.g SFP+, QSFP

--show-priv-flags
    Queries the specified network device for its private flags. The names and meanings of private flags (if any) are defined by each network device driver.

--set-priv-flags
    Sets the device's private flags as specified.

flag Sets the state of the named private flag.

--show-eee
    Queries the specified network device for its support of Energy-Efficient Ethernet (according to the IEEE 802.3az specifications)

--set-eee
    Sets the device EEE behaviour.

Enables/disables the device support of EEE.

Determines whether the device should assert its Tx LPI.

advertise N
    Sets the speeds for which the device should advertise EEE capabiliities. Values are as for --change advertise

tx-timer N
    Sets the amount of time the device should stay in idle mode prior to asserting its Tx LPI (in microseconds). This has meaning only when Tx LPI is enabled.

BUGS
Not supported (in part or whole) on all network drivers.

AUTHOR
ethtool was written by David Miller.

Modifications by Jeff Garzik, Tim Hockin, Jakub Jelinek, Andre Majorel, Eli Kupermann, Scott Feldman, Andi Kleen, Alexander Duyck, Sucheta Chakraborty.

AVAILABILITY
ethtool is available from http://www.kernel.org/pub/software/network/ethtool/